﻿Imports System.IO
Public Class Game
    Public Plocha(9, 9) As Integer
    Public Shared PlochaF As String = "fence.txt"

    Public Doplnovani(8, 1024) As Integer
    Public DoplnovaniIndex(8) As Integer
    Public DoplnovaniMax(8) As Integer

    Public Shared SelectedI As Point = New Point(-1, -1)
    Public Shared SelectedI2 As Point = New Point(-1, -1)

    Public Shared Points As Integer

    Public TimeLimit As Date = New Date()
    Public TimeLimitRemain As Date = New Date()
    Public EndTimeLimit As Date = New Date()
    Public EnableTimeLimit As Boolean = False
    Sub Var_init()
        RefreshTmr.Enabled = True
        EndTimeLimit = Now
        EndTimeLimit = Now.Add(New TimeSpan(0, 0, Form1.TLM.Text, Form1.TLS.Text))
        Try
            Dim Data() As String = File.ReadAllLines(PlochaF)
            'Doplňování
            For radek = 8 To Data.Length - 1
                For sloupec = 0 To Data(radek).Length - 1
                    Doplnovani(radek - 8, sloupec) = Data(radek)(sloupec).ToString()
                    DoplnovaniMax(radek - 8) = Data(radek).Length - 1
                Next
            Next
            'Plocha
            For x = 0 To 7
                For y = 0 To 7
                    Plocha(x, y) = Data(y)(x).ToString()
                Next
            Next
            'Ignorace
            For x = 0 To 8
                Plocha(x, 8) = -1
            Next
            For y = 0 To 8
                Plocha(8, y) = -1
            Next

            For x = 0 To 9
                Plocha(x, 9) = -1
            Next
            For y = 0 To 9
                Plocha(9, y) = -1
            Next
            Return
        Catch ex As Exception
            MsgBox("Došlo k chybě při načítání plochy: " & ex.Message)
            Environment.Exit(0)
        End Try
    End Sub
    Private Sub Game_Paint(sender As Object, e As PaintEventArgs) Handles MyBase.Paint
        For x = 0 To 7
            For y = 0 To 7
                e.Graphics.FillEllipse(New SolidBrush(ToRGBColor(Plocha(x, y))), x * 20, y * 20, 19, 19)
                If x = SelectedI.X And y = SelectedI.Y Then
                    e.Graphics.DrawRectangle(New Pen(Color.LightGreen, 2), x * 20, y * 20, 19, 19)
                End If
            Next
        Next
        If EnableTimeLimit Then
            e.Graphics.DrawString(TimeLimitRemain.Minute & ":" & TimeLimitRemain.Second, DefaultFont, Brushes.Black, New PointF(160, 0), StringFormat.GenericDefault)
        End If
    End Sub
    Public Function ToRGBColor(color As Integer) As Color
        Select Case color
            Case 0
                Return BackColor
            Case 1
                Return Drawing.Color.Red
            Case 2
                Return Drawing.Color.Green
            Case 3
                Return Drawing.Color.Blue
            Case 4
                Return Drawing.Color.White
            Case 5
                Return Drawing.Color.Yellow
            Case 6
                Return Drawing.Color.Violet
        End Select
    End Function

    Private Sub Game_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Var_init()
    End Sub

    Private Sub Game_FormClosed(sender As Object, e As FormClosedEventArgs) Handles MyBase.FormClosed
        Environment.Exit(0)
    End Sub
    Private Sub Delete3Points(x1, y1, x2, y2, x3, y3, ByRef Array)
        Array(x1, y1) = 0
        Array(x2, y2) = 0
        Array(x3, y3) = 0
    End Sub
    Public Sub Scene_Update()
        'Uznání, vymazání a detekce sledů
        Dim NewPlocha = Plocha
        For x = 0 To 7
            For y = 0 To 7
                SelectedI2 = New Point(x, y)
                Dim BaseColor As Integer = Plocha(x, y)
                'řádka
                If SelectedI2.X > 0 Then
                    If Plocha(SelectedI2.X - 1, SelectedI2.Y) = BaseColor And Plocha(SelectedI2.X + 1, SelectedI2.Y) = BaseColor Then
                        Points += 3
                        Delete3Points(x, y, x - 1, y, x + 1, y, NewPlocha)
                    End If
                End If
                If SelectedI2.X > 1 Then
                    If Plocha(SelectedI2.X - 1, SelectedI2.Y) = BaseColor And Plocha(SelectedI2.X - 2, SelectedI2.Y) = BaseColor Then
                        Points += 3
                        Delete3Points(x, y, x - 1, y, x - 2, y, NewPlocha)
                    End If
                End If
                If Plocha(SelectedI2.X + 1, SelectedI2.Y) = BaseColor And Plocha(SelectedI2.X + 2, SelectedI2.Y) = BaseColor Then
                    Points += 3
                    Delete3Points(x, y, x + 1, y, x + 2, y, NewPlocha)
                End If
                'sloupec
                If SelectedI2.Y > 0 Then
                    If Plocha(SelectedI2.X, SelectedI2.Y - 1) = BaseColor And Plocha(SelectedI2.X, SelectedI2.Y + 1) = BaseColor Then
                        Points += 3
                        Delete3Points(x, y, x, y - 1, x, y + 1, NewPlocha)
                    End If
                End If
                If SelectedI2.Y > 1 Then
                    If SelectedI2.Y > 1 And Plocha(SelectedI2.X, SelectedI2.Y - 1) = BaseColor And Plocha(SelectedI2.X, SelectedI2.Y - 2) = BaseColor Then
                        Points += 3
                        Delete3Points(x, y, x, y - 1, x, y - 2, NewPlocha)
                    End If
                End If
                If Plocha(SelectedI2.X, SelectedI2.Y + 1) = BaseColor And Plocha(SelectedI2.X, SelectedI2.Y + 2) = BaseColor Then
                    Points += 3
                    Delete3Points(x, y, x, y + 1, x, y + 2, NewPlocha)
                End If
            Next
        Next
        Plocha = NewPlocha

        Refresh()

        If ArrayContains(0, Plocha) Then
            Threading.Thread.Sleep(500)
        End If
        'Doplnění
        While ArrayContains(0, Plocha)
            For x = 0 To 7
                For y = 0 To 7
                    If Plocha(x, y) = 0 And y > 0 Then
                        Plocha(x, y) = Plocha(x, y - 1)
                        Plocha(x, y - 1) = 0
                    End If
                    If Plocha(x, y) = 0 And y = 0 Then
                        Plocha(x, y) = Doplnovani(y, DoplnovaniIndex(y))
                        DoplnovaniIndex(y) += 1
                        If DoplnovaniIndex(y) > DoplnovaniMax(y) Then
                            DoplnovaniIndex(y) = 0
                        End If
                    End If
                Next
            Next
        End While
        Invalidate()
    End Sub
    Function ArrayContains(val As Integer, Array As Integer(,)) As Boolean
        For x = 0 To Array.GetLength(0) - 1
            For y = 0 To Array.GetLength(1) - 1
                If val = Array(x, y) Then
                    Return True
                End If
            Next
        Next
        Return False
    End Function
    Private Sub Game_MouseDown(sender As Object, e As MouseEventArgs) Handles MyBase.MouseDown
        If e.X / 20 > 0 And e.X / 20 < 8 And e.Y / 20 > 0 And e.Y / 20 < 8 And e.Button = MouseButtons.Left Then
            SelectedI.X = (e.X - 10) / 20
            SelectedI.Y = (e.Y - 10) / 20
        End If
        If e.X / 20 > 0 And e.X / 20 < 8 And e.Y / 20 > 0 And e.Y / 20 < 8 And e.Button = MouseButtons.Right Then
            SelectedI2.X = (e.X - 10) / 20
            SelectedI2.Y = (e.Y - 10) / 20

            'check sousedtstvý
            If (SelectedI.X - 1 = SelectedI2.X And SelectedI.Y = SelectedI2.Y) Or (SelectedI.X = SelectedI2.X And SelectedI.Y - 1 = SelectedI2.Y) Or (SelectedI.X + 1 = SelectedI2.X And SelectedI.Y = SelectedI2.Y) Or (SelectedI.X = SelectedI2.X And SelectedI.Y + 1 = SelectedI2.Y) Then
                'check sledu
                Dim BaseColor As Integer = Plocha(SelectedI.X, SelectedI.Y)
                Dim NewPlocha = Plocha.Clone()

                'NewPlocha - init
                NewPlocha(SelectedI.X, SelectedI.Y) = NewPlocha(SelectedI2.X, SelectedI2.Y)
                NewPlocha(SelectedI2.X, SelectedI2.Y) = BaseColor

                Dim SledFinded As Boolean = False
                'řádka
                If SelectedI2.X > 0 Then
                    If NewPlocha(SelectedI2.X - 1, SelectedI2.Y) = BaseColor And NewPlocha(SelectedI2.X + 1, SelectedI2.Y) = BaseColor Then
                        SledFinded = True
                    End If
                End If
                If SelectedI2.X > 1 Then
                    If NewPlocha(SelectedI2.X - 1, SelectedI2.Y) = BaseColor And NewPlocha(SelectedI2.X - 2, SelectedI2.Y) = BaseColor Then
                        SledFinded = True
                    End If
                End If
                If NewPlocha(SelectedI2.X + 1, SelectedI2.Y) = BaseColor And NewPlocha(SelectedI2.X + 2, SelectedI2.Y) = BaseColor Then
                    SledFinded = True
                End If
                'sloupec
                If SelectedI2.Y > 0 Then
                    If NewPlocha(SelectedI2.X, SelectedI2.Y - 1) = BaseColor And NewPlocha(SelectedI2.X, SelectedI2.Y + 1) = BaseColor Then
                        SledFinded = True
                    End If
                End If
                If SelectedI2.Y > 1 Then
                    If NewPlocha(SelectedI2.X, SelectedI2.Y - 1) = BaseColor And NewPlocha(SelectedI2.X, SelectedI2.Y - 2) = BaseColor Then
                        SledFinded = True
                    End If
                End If
                If NewPlocha(SelectedI2.X, SelectedI2.Y + 1) = BaseColor And NewPlocha(SelectedI2.X, SelectedI2.Y + 2) = BaseColor Then
                    SledFinded = True
                End If
                'závěr
                If SledFinded Then
                    Plocha(SelectedI.X, SelectedI.Y) = Plocha(SelectedI2.X, SelectedI2.Y)
                    Plocha(SelectedI2.X, SelectedI2.Y) = BaseColor
                    SelectedI = New Point(-1, -1)
                End If
            End If
        End If
        Invalidate()
        Scene_Update()
    End Sub

    Private Sub RefreshTmr_Tick(sender As Object, e As EventArgs) Handles RefreshTmr.Tick
        Scene_Update()
        Refresh()
        If EnableTimeLimit Then
            'MessageBox.Show(EndTimeLimit.ToBinary() & "=" & Now.ToBinary())
            If EndTimeLimit.ToBinary() < Now.ToBinary() Then
                Threading.Thread.Sleep(1000)
                Environment.Exit(0)
            End If
            TimeLimitRemain = New Date().Add(Date.Parse(EndTimeLimit).Subtract(Date.Parse(Now)))
        End If
    End Sub

End Class